within ;
package Suspension

  model suspension_moto
    PlanarMechanics.Parts.Body body(
      
      a(fixed=true, start={0,0}),
      animate=true,
      enableGravity=true, phi(displayUnit = "rad"),
      v(fixed=true, start={13.9,0}))         annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={-22,50})));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation(r={0.7,0})
      annotation (Placement(transformation(extent={{8,30},{28,50}})));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation1(r={0.7,0})
      annotation (Placement(transformation(extent={{-56,30},{-36,50}})));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation2(r={0,0.5})
      annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={-62,28})));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation3(r={0,0.5})
      annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={56,30})));
    PlanarMechanics.Joints.Prismatic prismatic(                 r={0,1},
        useFlange=true)                                 annotation (Placement(
          visible = true, transformation(origin = {-62, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation4(r={0,0.4})
      annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={-62,-26})));
    PlanarMechanics.Joints.Revolute revolute(useFlange=true) annotation (
        Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={-62,-50})));
    PlanarMechanics.Parts.Body body1(
      I= 0.375,
      animate=true,
      enableGravity=true,
      m=12,
      w(fixed=true, start=-55.6))                                                annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=180,
          origin={-90,-68})));
    PlanarMechanics.Joints.Revolute revolute1(useFlange=true)
                                              annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={56,-48})));
    PlanarMechanics.Parts.Body body2(
      I= 0.375,
      animate=true,
      enableGravity=true,
      m=12,
      w(fixed=true, start=-55.6))
      annotation (Placement(transformation(extent={{88,-78},{108,-58}})));
    Modelica.Mechanics.Rotational.Components.Brake brake(cgeo = 0.12, fn_max = 3500, useSupport=
         true)
      annotation (Placement(transformation(extent={{-32,-70},{-12,-50}})));
    PlanarMechanics.Joints.Prismatic prismatic1(r={0,1}, useFlange=true)
                                                         annotation (Placement(
          transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={56,2})));
    PlanarMechanics.Parts.FixedTranslation fixedTranslation5(r={0,0.4})
      annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=90,
          origin={56,-24})));
    Modelica.Blocks.Sources.Ramp ramp(
      height=1,
      duration=0.1,
      startTime=0.2)
      annotation (Placement(visible = true, transformation(extent = {{-14, -34}, {6, -14}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Brake brake1(cgeo = 0.12, fn_max = 3500,
        useSupport=true)
      annotation (Placement(transformation(extent={{72,-56},{92,-36}})));
    PlanarMechanics.Joints.DryFrictionBasedRolling dryFrictionBasedRolling(
      R=0.25,
      mu_A=0.8,
      mu_S=0.8, phi(displayUnit = "rad", fixed = true),
      vAdhesion= 15,
      vSlide= 15,
      w(start=0), x(fixed = true),
      z(fixed=false))
                     annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=270,
          origin={-62,-86})));
    PlanarMechanics.Joints.DryFrictionBasedRolling dryFrictionBasedRolling1(
      R=0.25,
      mu_A=0.8,
      mu_S=0.8, phi(displayUnit = "rad"),
      vAdhesion= 15,
      vSlide= 15,
      w(start=0),
      z(start=0))     annotation (Placement(transformation(
          extent={{-10,-10},{10,10}},
          rotation=270,
          origin={56,-86})));
    Modelica.Mechanics.Translational.Components.SpringDamper springDamper2(c=
          20000, d=1000) annotation (Placement(visible = true, transformation(origin = {-30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
    Modelica.Mechanics.Translational.Components.SpringDamper springDamper(c=
          20000, d=1000) annotation (Placement(visible = true, transformation(origin = {94, -8}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
  inner PlanarMechanics.PlanarWorld planarWorld(animateGravity = true, animateWorld = true, enableAnimation = true)  annotation(
      Placement(visible = true, transformation(origin = {-80, 82}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(body.frame_a,fixedTranslation. frame_a) annotation (
      Line(points = {{-22, 40}, {8, 40}}, color = {95, 95, 95}, thickness = 0.5));
    connect(body.frame_a,fixedTranslation1. frame_b) annotation (
      Line(points = {{-22, 40}, {-36, 40}}, color = {95, 95, 95}, thickness = 0.5));
    connect(fixedTranslation1.frame_a,fixedTranslation2. frame_b) annotation (
      Line(points = {{-56, 40}, {-60, 40}, {-60, 38}, {-62, 38}}, color = {95, 95, 95}, thickness = 0.5));
    connect(fixedTranslation.frame_b,fixedTranslation3. frame_b) annotation (
      Line(points = {{28, 40}, {56, 40}}, color = {95, 95, 95}, thickness = 0.5));
  connect(fixedTranslation2.frame_a, prismatic.frame_b) annotation(
      Line(points = {{-62, 18}, {-62, 12}}, color = {95, 95, 95}, thickness = 0.5));
  connect(prismatic.frame_a, fixedTranslation4.frame_b) annotation(
      Line(points = {{-62, -8}, {-62, -16}}, color = {95, 95, 95}, thickness = 0.5));
    connect(fixedTranslation4.frame_a,revolute. frame_b) annotation (
      Line(points={{-62,-36},{-62,-40}},      color = {95, 95, 95}, thickness = 0.5));
    connect(brake.support,revolute. support) annotation (
      Line(points = {{-22, -70}, {-40, -70}, {-40, -56}, {-52, -56}}, color = {0, 0, 0}));
    connect(brake.flange_a,revolute. flange_a) annotation (
      Line(points = {{-32, -60}, {-36, -60}, {-36, -50}, {-52, -50}}, color = {0, 0, 0}));
    connect(prismatic1.frame_b,fixedTranslation3. frame_a) annotation (
      Line(points={{56,12},{56,20}},                color = {95, 95, 95}, thickness = 0.5));
    connect(revolute1.frame_b,fixedTranslation5. frame_a) annotation (
      Line(points = {{56, -38}, {56, -34}}, color = {95, 95, 95}, thickness = 0.5));
    connect(prismatic1.frame_a,fixedTranslation5. frame_b) annotation (
      Line(points={{56,-8},{56,-14}},                color = {95, 95, 95}, thickness = 0.5));
  connect(ramp.y, brake.f_normalized) annotation(
      Line(points = {{7, -24}, {-2, -24}, {-2, -49}, {-22, -49}}, color = {0, 0, 127}));
    connect(brake1.support,revolute1. support) annotation (
      Line(points={{82,-56},{76,-56},{76,-54},{66,-54}},          color = {0, 0, 0}));
    connect(revolute1.flange_a,brake1. flange_a) annotation (
      Line(points={{66,-48},{70,-48},{70,-46},{72,-46}},          color = {0, 0, 0}));
    connect(revolute.frame_a,dryFrictionBasedRolling. frame_a) annotation (
      Line(points = {{-62, -60}, {-62, -76}}, color = {95, 95, 95}, thickness = 0.5));
    connect(revolute1.frame_a,dryFrictionBasedRolling1. frame_a) annotation (
      Line(points = {{56, -58}, {56, -76}}, color = {95, 95, 95}, thickness = 0.5));
    connect(body2.frame_a,dryFrictionBasedRolling1. frame_a) annotation (
      Line(points={{88,-68},{56,-68},{56,-76}},        color = {95, 95, 95}, thickness = 0.5));
    connect(body1.frame_a,dryFrictionBasedRolling. frame_a) annotation (
      Line(points = {{-80, -68}, {-62, -68}, {-62, -76}}, color = {95, 95, 95}, thickness = 0.5));
  connect(ramp.y, brake1.f_normalized) annotation(
      Line(points = {{7, -24}, {82, -24}, {82, -35}}, color = {0, 0, 127}));
  connect(prismatic.support, springDamper2.flange_a) annotation(
      Line(points = {{-52, -4}, {-54, -4}, {-54, -10}, {-30, -10}}, color = {0, 127, 0}));
  connect(prismatic.flange_a, springDamper2.flange_b) annotation(
      Line(points = {{-52, 2}, {-52, 10}, {-30, 10}}, color = {0, 127, 0}));
  connect(prismatic1.flange_a, springDamper.flange_b) annotation(
      Line(points = {{66, 2}, {94, 2}}, color = {0, 127, 0}));
  connect(prismatic1.support, springDamper.flange_a) annotation(
      Line(points = {{66, -4}, {70, -4}, {70, -18}, {94, -18}}, color = {0, 127, 0}));
    annotation (Icon(coordinateSystem(preserveAspectRatio=false)), Diagram(
          coordinateSystem(preserveAspectRatio=false)));
  end suspension_moto;
  annotation (uses(Modelica(version = "3.2.2"), PlanarMechanics(version = "1.4.1")));
end Suspension;
